## RiskyMod
A full-game overhaul that aims to bring it closer to RoR1's balance. My main priority is multiplayer, but the mod is balanced in solo as well.

I highly recommed installing https://thunderstore.io/package/Moffein/EliteReworks/ to go with this.

Full change list can be found at https://docs.google.com/document/d/1Igxdur0M33fdkcDLYgDEbLE0M4-89gSTorxgdn-oyKs/

This mod merges in fixes and tweaks from a bunch of other mods. If you have those mods installed, these fixes/changes will disable and the original mod will take priority.

Feel free to take features of this mod and release them as standalone as long as you link the original GitHub repo in the README.

**Contact me if you're interested in translating the mod!**

## Main Features

- Oneshot Protection now actually works.
	- Oneshot = Going from >90% HP to 0% HP in under 0.5s
	- Once triggered, you have to be out of danger (no damage for 7s) before it can be retriggered.
- Shields gate against HP damage like the Guardian's Heart in RoR1.
- Big balance pass over nearly all the items.
	- Bad items like Squid Polyps and Warbanners have gotten substantial buffs.
	- Strong damage items like AtGs and Elemental Bands now have lowered damage stacking.
	- Most forms of range scaling have been removed, and most items aren't able to proc chain anymore.
- Big balance pass over all the Survivors
	- Less useless skill options, default Commando is good now!
- Drone performance now remains the same on all stages.

## Other Changes

- Combat Shrines give less money, but drop items for the team on completion.
- Teleporter radius expands once the boss is dead.
- Tweaked Commencement
	- Only 2 pillars are required to activate the jump pads.
	- Pillars drop items for the team on completion, and you can complete as many as you want.

## Installation
Place RiskyMod.dll **AND** the **language folder** in /Risk of Rain 2/BepInEx/plugins/RiskyMod

## Planned Changes (Not implemented yet)

- Make Google Doc more readable/pretty.
	- Split up into multiple separate docs?
- Tweak enemy pools

*Mostly done with everything I've wanted to do with the mod. Plan going forward is to iron out the existing balance. There's some items that I don't like but don't have any ideas for reworking, so I'll list them here and leave it up to you on whether you want to enable them in your runs.*

- Items I don't like but don't want to touch either:
	- Roll of Pennies
	- Lost Seer's Lens 
	- Regenerating Scrap
	- Executive Card
	
## For Developers

To make custom allies compatible with RiskyMod's ally changes, use these 4 items located in AllyItems.cs:

- AllyMarkerItem makes the holder benefit from Ally damage resistances. No effect when stacked.
- AllyScalingItem changes level scaling from +30% HP +20% damage -> +20% HP +30% damage so that allies perform the same on all stages. No effect when stacked.
- AllyRegenItem makes the holder's HP regenerate to full in X seconds, X being the amount of stacks.
- AllyAllowVoidDeathItem makes the holder to bypass the "No Void Death" config option.
- AllyAllowOverheatDeathItem makes the holder to bypass the "No Overheat" config option.
- AllyResistAoEItem enables the ResistantToAoE bodyflag on the holder, granting them +300 armor against attacks with DamageType.AoE

These are always initialized even if Ally changes are disabled and their effects have config-checking built-in, so you can simply add them to your allies without having to worry about anything.

Make sure these are only given to Player-team allies, since they'll be painful to fight against (in a bad/unintuitive way) when they're given to enemies.
	
## Credits

Drone Targeting fix - ZetTweaks

Squid Polyp Distraction - DestroyedClone

Language Support - Anreol

Skill Icons - KoobyKarasu

Acrid Hitbox Tweaks - TheTimesweeper

Buff Icons - SOM, VALE-X

## Changelog

`0.13.12`

- Void Locus
	- Tweaked Fog Damage
		- Reduced HP% per second from 5% -> 2.5%
		- Removed damage rampup over time.
		
		*Void Fields got changed in an update post-SotV to make the fog damage more reasonable, but Void Locus never received that change. New numbers are the same as current Void Fields.*
	
	- Remove Fog
		- Changed default config setting from Enabled to Disabled. (Only affects newly-generated configs. Existing configs won't change.)
		
		*This was originally enabled by default due to the Void Fog being unplayable in large lobbies, along with the Fog killing too fast to catch up to teammates who decided to activate Signals early.*
		
- Items
	- Crowbar
		- Increased damage from +45% -> +50%
		
	- Queen's Gland, Empathy Cores, Defense Nucleus, Newly-Hatched Zoea, Halcyon Seed, Backup, Goobo Jr.
		- Separated Ally Changes from Item Changes. Item config no longer prevents Ally Changes from being applied.
		
		*This is how it used to work pre-0.13. Item config affects the actual stats/stacking, while the general game-wide ally scaling changes are tied to the Ally Changes config.*

`0.13.11`

- Spawnpools (Beta)
	- Siphoned Forest
		- Moved Bighorn Bisons back to being post-loop enemies.
		
		*Having Vermin, Pests, and Bisons on Stage 1 ended up making this stage feel skewed.*

`0.13.10`

- Enemies
	- Bighorn Bison
		- Disabled snow VFX overlay when spawning on non-snowy stages.
		- Increased Charge speed coefficient from 8 -> 12
		- Increased Charge turn speed from 300 -> 600
		- Reduced Charge self-stun duration from 3s -> 1s to match other stunning effects.
		
		*Partially inspired by Inferno's changes, should be compatible with it. Vanilla Bisons are too slow and unmaneuverable to be much of a threat. Faster charge speed should make them a bit harder to dodge. Turn speed has been increased as well, but I'm not sure if it's actually doing anything.*
	
- Spawnpools (Beta)
	- Titanic Plains
		- Bighorn Bisons can spawn post-loop and during Simulacrum.
	- Siphoned Forest
		- Bighorn Bisons can now spawn on the first loop.

`0.13.9`

- Artificer
	- Fixed Ice Wall not freezing when cast on midair enemies.
	
	*This bug was introduced a few versions ago when it got changed from Blast Jumping to a simple backwards push.*

`0.13.8`

- Defense Nucleus
	- Fixed another coding oversight related to the HealthDecay item when the "Inherit Elite Affix" config option is disabled.

`0.13.7`

- Defense Nucleus
	- Fixed some coding oversights.

`0.13.6`

- Queens Gland
	- [Compatibility] Fixed QueensGlandBuff's stats getting overwritten by RiskyMod's.

- Squid Polyp
	- Increased lifetime from 30s -> 40s
	
	*Intended to mirror how allies take 40s to regen to full.*
	
- Defense Nucleus
	- Now decays over 40s.
	- Added AoE resistance.
	
	*These would spawn on one side of the map, then sit there doing nothing while the fight has moved to another part of the map.

`0.13.5`

- Power Elixir (Rework)
	- Triggers when HP is 50% or lower after taking damage.
		- Counts actual HP only.
	- When triggered, rapidly regenerates 50% of your HP over 4 seconds.
		- Cannot retrigger while regen is active.
		- Unaffected by difficulty.
	- Breaks when triggered. Resets on the next stage.
	
	*Removing perma-break effect while trying to keep the spirit of the Vanilla item. 50% threshold will make this more consistent to trigger, but with a weaker healing effect to compensate for being more readily-accessible.*

`0.13.4`

- Fixed purchaseable drones not receiving ally-related items.
	- Fixes drones taking damage from Void Fog.
	- Fixes drones dying to Void Reaver explosions.
- Fixed Void Reaver changes not working.

`0.13.3`

- Fixed styling on Razorwire description.
- Increased Shatterspleen bleed chance from 5% -> 10%
	
	*No other +5% bleed chance items exist in the game, which made this feel out of place.*

`0.13.2`

- Little Disciple
	- Increased proc coefficient from 0 -> 0.5
	
	*Been on the fence about doing this for some time. After playing a lot with 0 proc Disciple, I've come to the conclusion that it needs some proc coefficient to be worthwhile.*

`0.13.1`

- Queens Gland, Defense Nucleus, Empathy Cores
	- Can now die to Void Implosions.
	
	*Enabling Void Implosion deaths on expendable allies that can easily respawn, as a stylistic touch. Things that don't respawn easily (Aureleonite, Col. Droneman, Drones in general) will remain immune to Void Implosions.*

`0.13.0`

- Compatibility and Configs
	- Added console messages to notify when a RiskyMod feature is disabled due to another plugin being loaded.
	- Fixed Sacrifice change conflicting with the standalone SacrificeTweaks plugin.
	- Repairable TC280 config option is no longer disabled when ZetTweaks is installed. It will instead give a console warning to let you know that you need to disable it in either plugin.
	- Added config options for Spawnpools beta.
		- Spawnpools will remain in beta until DirectorAPI gets updated to be more stable.

- AI Blacklist
	- Blacklisted Safer Spaces due to the possibility of unkillable enemies at high stacks.
	
- Survivors
	- MUL-T
		- Power Saw config now allows you to individually enable Physics Changes and Barrier-On-Hit.
	- REX
		- Removed leftover Swap Utility Effects code that was supposed to be removed in a previous update.
			- Alt Utility no longer applies Weaken.
			- Config option has been changed to "DIRECTIVE: Disperse Healing"

- Allies
	- Refactored code to be a LOT cleaner.
		- Added internal items to allow other modders to make their allies compatible with RiskyMod.
	
		*See the For Developers section of the README for more info!*
		
	- Increased Mushrum resistance from -67% damage -> -75% damage.
	- Drones
		- Repairing drones that were destroyed in combat is now 50% cheaper.
		
		- Missile Drone
			- Increased HP from 225 -> 250
		
		- Incinerator Drone
			- Increased HP from 300 -> 340
			- Increased range from 18m -> 25m (same as Artificer Flamethrower changes)
			
		- Emergency Drone
			- Increased HP from 300 -> 340
			- Reduced price from $100 -> $80
		
		- TC280
			- Mega Turret
				- Bullets are now explosive.
					- Damage remains the same.
				- Shot count increases with attack speed.
			- Rockets
				- Remove blast falloff.
			- New Passive: Shield Overload
				- When health goes below 25% HP, shock nearby enemies and temporarily gain a massive amount of shield.
				- 60s cooldown.
			- Gibs despawn after 15 seconds.
			
			*Is this too much?*
			
		- Col. Droneman
			- Increased HP from 180 -> 200
			- Added shields.
	
- Items
	- Happiest Mask
		- Reduced damage bonus from 900% (+240%) -> 600% (+180%)
			- Description incorrectly listed this as 800%
		- Now benefits from Ally changes.
		
		*Damage reduction is due to the +50% level damage scaling increase from Ally Scaling.*
		
	- Queen's Gland
		- Enemy Queen's Gland Guards no longer benefit from Ally changes.
		- Fixed initial stack damage being set to 400% instead of 300%
		- Description now correctly lists the first stack HP as 200% instead of 100%.
		
	- Empathy Cores
		- Enemy Empathy Cores no longer benefit from Ally changes.
		
	- Halcyon Seed
		- Now benefits from Ally changes.
		
	- Defense Nucleus
		- Now benefits from Ally changes.
		
	- Newly-Hatched Zoea
		- Removed hidden +50% damage bonus.
		- Now benefits from Ally changes.
			- Can still die to Void Implosions.
			
- Equipment
	- Goobo Jr.
		- Fixed damage being set to 400% instead of 300%
		- Fixed HP being set to 700% instead of 600%
		- Now benefits from Ally changes.
	
- Enemies
	- Aureleonite
		- Damage increased from 40 -> 60
		
- Spawnpools Beta
	- Siphoned Forest
		- Removed Beetles
		- Blind Vermin can now spawn on the first loop